extern "C" {
#include "fmopl.h"
}

#include "fmdrv/sysdeps.h"

#include "timers.hh"
#include "pcm.hh"

#include <stdio.h>
#include <string.h>

static timer pcmtimer;
static PCM pcm;

static FM_OPL *opl;
static void Create()
{
	if(!opl)
	{
		opl = OPLCreate(OPL_TYPE_WAVESEL, 1789772*2, pcm.getrate());
		OPLResetChip(opl);
	}
}

static int oplretval;
void Fmdrv_Outportb(unsigned port, unsigned char value)
{
	if(port >= 0x388 && port <= 0x38B)
	{
		Create();
		
		unsigned ind = port-0x388;
		OPLWrite(opl, ind, value);
		
		if(ind & 1)
		{
			if(opl->address == 4)
			{
				if(value == 0x80)oplretval = 0x02;
				else if(value ==0x21)oplretval = 0xC0;
			}
		}
	}
}

unsigned char Fmdrv_Inportb(unsigned port)
{
	if(port >= 0x388 && port <= 0x38B)
	{
		return oplretval;
	}
	return 0;
}

void Fmdrv_Usleep(unsigned usecs)
{
	double nrate = 1.0 / opl->rate;
	unsigned count = pcmtimer.Advance(nrate, usecs / 1E6);
	
	INT32 buf[count];
	memset(buf, 0, sizeof buf);
	
	YM3812UpdateOne(opl, buf, count);

	for(unsigned a=0; a<count; ++a)
	{
		pcm.output(buf[a] / 32768.0);
	}
}


/* Looking for main() ?
 * See fmdrv/main.c
 *
 * The emulator has no main().
 * The main() is in fmdrv, which is the program
 * which uses here emulation for testing.
 *
 */
